# to cache both npm modules and Cypress binary we use environment variables
# to point at the folders we can list as paths in "cache" job settings
variables:
  NPM_CACHE_DIR: "$CI_PROJECT_DIR/cache/npm"
  CYPRESS_CACHE_FOLDER: "$CI_PROJECT_DIR/cache/Cypress"

# cache using branch name
# https://gitlab.com/help/ci/caching/index.md
cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .npm/
    - cache/Cypress

# this job installs NPM dependencies and Cypress
test:
  image: cypress/base:12.19.0
  script:
    - npm ci --cache .npm --prefer-offline
    # check Cypress binary path and cached versions
    # useful to make sure we are not carrying around old versions
    - npx cypress cache path
    - npx cypress cache list
    - npm run cypress:verify
    # start the server, wait for it to respond, then run Cypress tests
    # - NODE_ENV=test npm test
    # Run e2e cypress tests
    - npx nx run todo-e2e:e2e --headless
    # print all files in "cypress" folder
    #- ls -laR cypress
    - ls apps/todo-e2e/.nyc_output/
    # copy nyc_output folder at root level
    - cp -R apps/todo-e2e/.nyc_output .
    # print coverage summary so that GitLab CI can parse the coverage number
    # from a string like "Statements   : 100% ( 135/135 )"
    - npx nyc report --reporter=text-summary
